package com.sun.org.apache.bcel.internal.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantFloat extends Constant implements ConstantObject
{
    private float bytes;
    
    public ConstantFloat(float bytes) {
        super((byte)4);
        this.bytes = bytes;
    }
    
    public ConstantFloat(ConstantFloat c) {
        this(c.getBytes());
    }
    
    ConstantFloat(DataInput file) throws IOException {
        this(file.readFloat());
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitConstantFloat(this);
    }
    
    @Override
    public final void dump(DataOutputStream file) throws IOException {
        file.writeByte((int)super.getTag());
        file.writeFloat(this.bytes);
    }
    
    public final float getBytes() {
        return this.bytes;
    }
    
    public final void setBytes(float bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public final String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
    
    @Override
    public Object getConstantValue(ConstantPool cp) {
        return new Float(this.bytes);
    }
}
